%define apuver 1
%define libname %mklibname apr-util %{apuver}
%define develname %mklibname -d apr-util

Summary:	Apache Portable Runtime Utility library
Name:		apr-util
Version:	1.2.12
%define subrel 2
Release:	%mkrel 4
License:	Apache License
Group:		System/Libraries
URL:		http://apr.apache.org/
Source0:	http://www.apache.org/dist/apr/apr-util-%{version}.tar.gz
Source1:	http://www.apache.org/dist/apr/apr-util-%{version}.tar.gz.asc
# http://apache.webthing.com/database/apr_dbd_mysql.c
# http://apache.webthing.com/svn/apache/apr/apr_dbd_mysql.c
Source2:	apr_dbd_mysql.c
Patch0:		apr-util-1.2.2-config.diff
Patch2:		apr-util-postgresql.diff
Patch3:		apr-util-1.2.8-no_linkage.diff
Patch4:		apr-util-1.2.7-dso.diff
Patch5:		apr-util-1.2.7-link.diff
Patch6:		apr-util-1.2.7-apr_dbd_mysql_headers.diff
Patch7:		apr-util-1.3.x-CVE-2009-0023.diff
Patch8:		apr-util-1.3.x-CVE-2009-1955.diff
Patch9:		apr-util-1.3.x-CVE-2009-1956.diff
Patch10:	apr-util-1.x-CVE-2009-2412.diff
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
BuildRequires:	libtool
BuildRequires:	doxygen
BuildRequires:	apr-devel >= 1.2.12
BuildRequires:	openldap-devel
BuildRequires:	db4-devel
BuildRequires:	expat-devel
BuildRequires:	openssl-devel
BuildRequires:	mysql-devel
BuildRequires:	postgresql-devel
BuildRequires:	sqlite3-devel
BuildRequires:	python
%if %mdkversion >= 1020
BuildRequires:	multiarch-utils >= 1.0.3
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package -n	%{libname}
Summary:	Apache Portable Runtime Utility library
Group: 		System/Libraries
Provides:	%{name} = %{version}-%{release}
Provides:	lib%{name} = %{version}-%{release}
Obsoletes:	lib%{name} %{name}

%description -n	%{libname}
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package	dbd-pgsql
Summary:	DBD driver for PostgreSQL
Group:		System/Libraries
License:	Apache License
Requires:	%{libname} = %{version}-%{release}

%description	dbd-pgsql
DBD driver for PostgreSQL.

%package	dbd-mysql
Summary:	DBD driver for MySQL
Group:		System/Libraries
License:	GPL
Requires:	%{libname} = %{version}-%{release}

%description	dbd-mysql
DBD driver for MySQL.

%package	dbd-sqlite3
Summary:	DBD driver for SQLite 3
Group:		System/Libraries
License:	Apache License
Requires:	%{libname} = %{version}-%{release}

%description	dbd-sqlite3
DBD driver for SQLite 3.

%package -n	%{develname}
Group:		Development/C
Summary:	APR utility library development kit
Requires:	%{name} = %{version}
Requires:	%{libname} = %{version}-%{release}
Requires:	apr-util = %{version}
Requires:	apr-devel
Requires:	openldap-devel
#Requires:	db4-devel
Requires:	expat-devel
Provides:	%{libname}-devel = %{version}
Obsoletes:	%{libname}-devel
Provides:	%{name}-devel = %{version}
Obsoletes:	%{name}-devel

%description -n	%{develname}
This package provides the support files which can be used to 
build applications using the APR utility library.  The mission 
of the Apache Portable Runtime (APR) is to provide a free 
library of C data structures and routines.

%prep

%setup -q -n %{name}-%{version}
%patch0 -p0 -b .config
%patch2 -p1 -b .postgresql
%patch3 -p0 -b .exports
%patch4 -p0 -b .dso
%patch5 -p0 -b .link

cp %{SOURCE2} dbd/apr_dbd_mysql.c
%patch6 -p0 -b .mysql_headers
head -46 dbd/apr_dbd_mysql.c > LICENSE.apr_dbd_mysql

%patch7 -p0 -b .CVE-2009-0023
%patch8 -p0 -b .CVE-2009-1955
%patch9 -p0 -b .CVE-2009-1956
%patch10 -p0 -b .CVE-2009-2412

cat >> config.layout << EOF
<Layout NUX>
    prefix:        %{_prefix}
    exec_prefix:   %{_prefix}
    bindir:        %{_bindir}
    sbindir:       %{_sbindir}
    libdir:        %{_libdir}
    libexecdir:    %{_libexecdir}
    mandir:        %{_mandir}
    infodir:       %{_infodir}
    includedir:    %{_includedir}/apr-%{apuver}
    sysconfdir:    %{_sysconfdir}
    datadir:       %{_datadir}
    installbuilddir: %{_libdir}/apr-%{apuver}/build
    localstatedir: /var
    runtimedir:    /var/run
    libsuffix:     -\${APRUTIL_MAJOR_VERSION}
</Layout>
EOF

%build
%serverbuild

# We need to re-run ./buildconf because of any applied patch(es)
#./buildconf --with-apr=%{_prefix}

# buildconf is borked...
cp %{_libdir}/apr-%{apuver}/build/apr_common.m4 %{_libdir}/apr-%{apuver}/build/find_apr.m4 %{_libdir}/apr-%{apuver}/build/gen-build.py build/

# conditional lib64 hack
%if "%{_lib}" != "lib"
perl -pi -e "s|/lib\b|/%{_lib}|g" build/*.m4
%endif

export WANT_AUTOCONF_2_5=1
rm -f configure
libtoolize --copy --force; aclocal-1.7; autoconf --force
python build/gen-build.py make

%{__sed} -i -e '/OBJECTS_all/s, dbd/apr_dbd_[^ ]*\.lo,,g' build-outputs.mk

# use sqlite3 only
export apu_have_sqlite2='0'
cat >> config.cache << EOF
ac_cv_header_sqlite_h=no
ac_cv_lib_sqlite_sqlite_open=no
EOF

%configure2_5x \
    --cache-file=config.cache \
    --with-apr=%{_prefix} \
    --includedir=%{_includedir}/apr-%{apuver} \
    --with-installbuilddir=%{_libdir}/apr-%{apuver}/build \
    --enable-layout=NUX \
    --with-ldap \
    --with-mysql=%{_prefix} \
    --with-pgsql=%{_prefix} \
    --without-sqlite2 \
    --with-sqlite3=%{_prefix} \
    --with-berkeley-db \
    --without-gdbm

%make
make dox

%{__make} dbd/apr_dbd_mysql.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version -module dbd/apr_dbd_mysql.lo -lmysqlclient_r -o dbd/apr_dbd_mysql.la

%{__make} dbd/apr_dbd_pgsql.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version -module dbd/apr_dbd_pgsql.lo -lpq -o dbd/apr_dbd_pgsql.la

%{__make} dbd/apr_dbd_sqlite3.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version -module dbd/apr_dbd_sqlite3.lo -lsqlite3 -o dbd/apr_dbd_sqlite3.la

#pushd test
#    make check
#popd

# Run the less verbose test suites
# pushd test
# make testall testrmm testdbm
# ./testall -v -q
# ./testrmm
# ./testdbm auto tsdbm
# ./testdbm -tDB auto tbdb.db
# popd

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%makeinstall_std

libtool --mode=install %{_bindir}/install -c -m 755 dbd/apr_dbd_mysql.la %{buildroot}%{_libdir}
libtool --mode=install %{_bindir}/install -c -m 755 dbd/apr_dbd_pgsql.la %{buildroot}%{_libdir}
libtool --mode=install %{_bindir}/install -c -m 755 dbd/apr_dbd_sqlite3.la %{buildroot}%{_libdir}

# Documentation
rm -rf html; cp -rp docs/dox/html html

# Remove unnecessary exports from dependency_libs
sed -ri '/^dependency_libs/{s,-l(pq|sqlite[0-9]|mysqlclient_r|rt|dl|uuid) ,,g}' \
    %{buildroot}%{_libdir}/libapr*.la

# here as well
sed -ri '/^dependency_libs/{s,%{_libdir}/lib(sqlite[0-9]|mysqlclient_r)\.la ,,g}' \
    %{buildroot}%{_libdir}/libapr*.la

# multiacrh anti-borker
perl -pi -e "s|^LDFLAGS=.*|LDFLAGS=\"\"|g" %{buildroot}%{_bindir}/apu-%{apuver}-config

# includes anti-borker
perl -pi -e "s|-I%{_includedir}/mysql||g" %{buildroot}%{_bindir}/apu-%{apuver}-config

# Unpackaged files
rm -f %{buildroot}%{_libdir}/aprutil.exp

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root,-)
%doc CHANGES LICENSE
%{_libdir}/libaprutil-%{apuver}.so.*

%files -n %{develname}
%defattr(-,root,root,-)
%doc --parents html
%attr(755,root,root) %{_bindir}/apu-%{apuver}-config
%{_libdir}/libaprutil-%{apuver}.*a
%{_libdir}/libaprutil-%{apuver}.so
%{_libdir}/apr_dbd_mysql.*a
%{_libdir}/apr_dbd_pgsql.*a
%{_libdir}/apr_dbd_sqlite3.*a
%{_libdir}/pkgconfig/*.pc
%{_includedir}/apr-%{apuver}/*.h

%files dbd-mysql
%defattr(644,root,root,755)
%doc LICENSE.apr_dbd_mysql
%attr(755,root,root) %{_libdir}/apr_dbd_mysql.so

%files dbd-pgsql
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/apr_dbd_pgsql.so

%files dbd-sqlite3
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/apr_dbd_sqlite3.so


%changelog
* Wed Aug 05 2009 Oden Eriksson <oeriksson@mandriva.com> 1.2.12-4.2mdv2008.1
- P10: security fix for CVE-2009-2412

* Sat Jun 06 2009 Oden Eriksson <oeriksson@mandriva.com> 1.2.12-4.1mdv2008.1
- P7: security fix for CVE-2009-0023
- P8: security fix for CVE-2009-1955
- P9: security fix for CVE-2009-1956
- fix the postgresql header patch (P2)

* Thu Jan 24 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.12-4mdv2008.1
+ Revision: 157327
- rebuild

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild with fixed %%serverbuild macro

* Fri Dec 21 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.12-2mdv2008.1
+ Revision: 136281
- rebuilt against new build deps

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Nov 28 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.12-1mdv2008.1
+ Revision: 113581
- 1.2.12
- rediffed P3

* Thu Sep 06 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-1mdv2008.0
+ Revision: 80714
- 1.2.10 (release)

* Wed Sep 05 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.10-0.1mdv2008.0
+ Revision: 79881
- 1.2.10
- drop P1, not needed anymore
- new apr_dbd_mysql.c

* Sat Aug 18 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-7mdv2008.0
+ Revision: 65566
- really use the new devel package naming (duh!)

* Sat Aug 18 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-6mdv2008.0
+ Revision: 65565
- use the new devel package naming
- fix BuildPrereq rpmlint errors

* Sat Jun 23 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-5mdv2008.0
+ Revision: 43404
- use the new %%serverbuild macro

* Thu Jun 07 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-4mdv2008.0
+ Revision: 36657
- use distro conditional -fstack-protector


* Sat Jan 27 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-3mdv2007.0
+ Revision: 114291
- new version of apr_dbd_mysql.c with clearified license too

* Fri Jan 19 2007 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-2mdv2007.1
+ Revision: 110700
- rebuilt against new postgresql libs

* Sun Dec 10 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.8-1mdv2007.1
+ Revision: 94535
- 1.2.8
- rediffed patches; P2,P3
- drop upstream patches; P7,P8

* Thu Nov 16 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-10mdv2007.1
+ Revision: 84755
- sync with fedora (1.2.7-4)
- new apr_dbd_mysql.c (better 5.x support)
- Import apr-util

* Tue Sep 05 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-9mdv2007.0
- rebuilt against MySQL-5.0.24a-1mdv2007.0 due to ABI changes

* Tue Jul 18 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-8mdk
- rebuild

* Tue Jul 18 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-7mdk
- rebuild

* Tue Jul 18 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-6mdk
- make it build (P6)

* Tue Jul 18 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-5mdk
- new apr_dbd_mysql (S2)

* Wed Jul 12 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-4mdk
- rebuild

* Mon May 01 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-3mdk
- added PLD patches and spec file magic (P3,P4)
- new apr_dbd_mysql (S2)

* Mon May 01 2006 Stefan van der Eijk <stefan@eijk.nu> 1.2.7-2mdk
- rebuild for sparc

* Sat Apr 15 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.7-1mdk
- 1.2.7

* Thu Mar 30 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.6-1mdk
- 1.2.6

* Tue Mar 21 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.5-1mdk
- 1.2.5

* Wed Dec 14 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.2-2mdk
- fix deps (spturtle)

* Mon Dec 12 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.2-1mdk
- 1.2.2
- merge with the apr package from contrib
- merge fedora changes (1.2.2-2)

* Sun Oct 30 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.7-3mdk
- rebuilt to provide a -debug package too

* Mon Oct 17 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.7-2mdk
- rebuild

* Tue Oct 11 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.7-1mdk
- 0.9.7
- drop upstream patches; P8

* Tue Sep 06 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.6-8mdk
- rebuild

* Wed Aug 31 2005 Buchan Milne <bgmilne@linux-mandrake.com> 0.9.6-7mdk
- Rebuild for libldap2.3

* Sun Jun 12 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.6-6mdk
- rebuilt against new openldap and sasl libs
- enable gdbm linkage

* Tue May 17 2005 Oden Eriksson <oeriksson@mandriva.com> 0.9.6-5mdk
- added P8 for apr_memcache

* Fri Mar 18 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.6-4mdk
- use the %%mkrel macro

* Wed Feb 23 2005 Stefan van der Eijk <stefan@eijk.nu> 0.9.6-3mdk
- Remove "Requires: db4-devel" from -devel package #13906

* Mon Feb 07 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.6-2mdk
- rebuilt against new ldap libs

* Mon Feb 07 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.6-1mdk
- 0.9.6

* Fri Feb 04 2005 Buchan Milne <bgmilne@linux-mandrake.com> 0.9.5-16mdk
- rebuild for ldap2.2_7

* Thu Jan 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-15mdk
- run the tests before %%makeinstall_std
- misc spec file fixes

* Tue Jan 11 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-14mdk
- make --with debug work

* Thu Jan 06 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-13mdk
- lib64 fixes

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-12mdk
- revert latest "lib64 fixes"

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-11mdk
- lib64 fixes

* Thu Nov 25 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-10mdk
- 0.9.5

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-9mdk
- new P0
- drop P100, it's included

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-8mdk
- security fix (P100) for CAN-2004-0786

* Wed Aug 11 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-7mdk
- rebuilt against db4.2

* Thu Jul 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-6mdk
- new P0
- drop P3,P4,P6 and P8 the fix is implemented upstream
- drop P5, another fix is implemented upstream
- fix P7, it's partially implemented upstream

* Fri Jun 18 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.9.5-5mdk
- rebuild with new openssl

* Fri Jun 18 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.9.5-4mdk
- rebuild

* Wed May 19 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-2mdk
- rebuild

* Sat May 08 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.9.5-1mdk
- initial fedora import and mandrake adaptions

* Fri Apr 02 2004 Joe Orton <jorton@redhat.com> 0.9.4-14
- fix use of SHA1 passwords (#119651)

* Wed Mar 31 2004 Joe Orton <jorton@redhat.com> 0.9.4-13
- remove fundamentally broken check_sbcs() from xlate code

* Fri Mar 19 2004 Joe Orton <jorton@redhat.com> 0.9.4-12
- tweak xlate fix

* Fri Mar 19 2004 Joe Orton <jorton@redhat.com> 0.9.4-11
- rebuild with xlate fixes and tests enabled

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com> 0.9.4-10.1
- rebuilt

* Tue Mar 02 2004 Joe Orton <jorton@redhat.com> 0.9.4-10
- rename sdbm_* symbols to apu__sdbm_*

* Mon Feb 16 2004 Joe Orton <jorton@redhat.com> 0.9.4-9
- fix sdbm apr_dbm_exists() on s390x/ppc64

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 0.9.4-8
- rebuilt

* Thu Feb 05 2004 Joe Orton <jorton@redhat.com> 0.9.4-7
- fix warnings from use of apr_optional*.h with gcc 3.4

* Thu Jan 29 2004 Joe Orton <jorton@redhat.com> 0.9.4-6
- drop gdbm support

